Subject: Re: linux-next: Tree for Aug 20 (Wno-alloc-size-larger-than)

From: Kees Cook <[email-masked]>
Date: Wed, 25 Aug 2021 22:23:07 -0700

On Wed, Aug 25, 2021 at 10:10:24PM -0700, Randy Dunlap wrote:
> On 8/25/21 8:54 PM, Kees Cook wrote:
> > On Wed, Aug 25, 2021 at 10:49:19AM -0700, Randy Dunlap wrote:
> > > On 8/25/21 10:04 AM, Kees Cook wrote:
> > > > On Tue, Aug 24, 2021 at 11:58:59AM +1000, Stephen Rothwell wrote:
> > > > > On Mon, 23 Aug 2021 18:24:44 -0700 Randy Dunlap <[email-masked]> wrote:
> > > > > > 
> > > > > > This is just weird. What I am seeing is that for every source file
> > > > > > where gcc emits a warning: it then follows that up with this
> > > > > > > > cc1: warning: unrecognized command line option '-Wno-alloc-size-larger-than'
> > > > > 
> > > > > I see the same, as well as:
> > > > > 
> > > > > <stdin>:1515:2: warning: #warning syscall clone3 not implemented [-Wcpp]
> > > > > cc1: warning: unrecognized command line option '-Wno-alloc-size-larger-than'
> > > > > 
> > > > > But only on my gcc 7.3.1 builds (the rest are gcc 10).
> > > > > 
> > > > > > Smells like a gcc bug to me.
> > > > > 
> > > > > Yes
> > > > > 
> > > > > Also noted here: https://github.com/DynamoRIO/drmemory/issues/2099 (second comment)
> > > > 
> > > > Okay, I think this work-around should work. I've been able to reproduce
> > > > the weird conditions, and this seems to behave correctly. Andrew, can
> > > > you fixup the fixup with this?
> > > > 
> > > > 
> > > > diff --git a/Makefile b/Makefile
> > > > index 26640899e7ca..c1842014a5de 100644
> > > > --- a/Makefile
> > > > +++ b/Makefile
> > > > @@ -1094,8 +1094,13 @@ endif
> > > >    ifdef CONFIG_CC_IS_GCC
> > > >    # The allocators already balk at large sizes, so silence the compiler
> > > > -# warnings for bounds checks involving those possible values.
> > > > -KBUILD_CFLAGS += $(call cc-option, -Wno-alloc-size-larger-than)
> > > > +# warnings for bounds checks involving those possible values. While
> > > > +# -Wno-alloc-size-larger-than would normally be used here, some versions
> > > > +# of gcc (<9.1) weirdly don't handle the option correctly when _other_
> > > > +# warnings are produced (?!), so instead use SIZE_MAX to effectively
> > > > +# disable it.
> > > > +# https://lore.kernel.org/lkml/[email-masked]
> > > > +KBUILD_CFLAGS += $(call cc-option, -Walloc-size-larger-than=SIZE_MAX)
> > > >    endif
> > > >    # disable invalid "can't wrap" optimizations for signed / pointers
> > > > 
> > > 
> > > Hi Kees,
> > > 
> > > I get a lot of these:
> > > 
> > > ../include/linux/slab.h: In function ‘keyctl_instantiate_key_common’:
> > > cc1: warning: invalid argument ‘SIZE_MAX’ to ‘-Walloc-size-larger-than=’
> > 
> > O_o
> > 
> > I love how the documentation on this option is consistently wrong. :)
> > 
> > I haven't been able to exactly reproduce this error on godbolt.org, but
> > I got close with trunk GCC:
> > gcc: error: argument to '-Walloc-size-larger-than=' should be a non-negative integer optionally followed by a size unit
> > 
> > Even though stdint.h is included. :(
> > 
> > Okay. How about _this_ fix?
> > 
> > diff --git a/Makefile b/Makefile
> > index efa9bd36b158..141a851930e6 100644
> > --- a/Makefile
> > +++ b/Makefile
> > @@ -1096,8 +1096,17 @@ endif
> >   ifdef CONFIG_CC_IS_GCC
> >   # The allocators already balk at large sizes, so silence the compiler
> > -# warnings for bounds checks involving those possible values.
> > -KBUILD_CFLAGS += $(call cc-option, -Wno-alloc-size-larger-than)
> > +# warnings for bounds checks involving those possible values. While
> > +# -Wno-alloc-size-larger-than would normally be used here, earlier versions
> > +# of gcc (<9.1) weirdly don't handle the option correctly when _other_
> > +# warnings are produced (?!). Using -Walloc-size-larger-than=SIZE_MAX
> > +# doesn't work (as it is documented to), silently resolving to "0" prior to
> > +# version 9.1 (and producing an error more recently). Numeric values larger
> > +# than PTRDIFF_MAX also don't work prior to version 9.1, which are silently
> > +# ignored, continuing to default to PTRDIFF_MAX. So, left with no other
> > +# choice, we must perform a versioned check to disable this warning.
> > +# https://lore.kernel.org/lkml/[email-masked]
> > +KBUILD_CFLAGS += $(call cc-ifversion, -ge, 0901, -Wno-alloc-size-larger-than)
> >   endif
> >   # disable invalid "can't wrap" optimizations for signed / pointers
> 
> Yes, this works for me. Thanks.
> 
> Tested-by: Randy Dunlap <[email-masked]>

Oh good! I've slowly been losing my mind trying to find a solution. :)
Thanks for testing each attempt!

-Kees

-- 
Kees Cook